﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Data;
using ScaffoldingWithDataTable.Models;

namespace ScaffoldingWithDataTable.Controllers
{
    public class PersonController : Controller
    {

        static DataTable dt = new DataTable();
        public PersonController()
        {
            if (dt.Columns.Count == 0)
            {
                dt.Columns.Add(new DataColumn("Code", typeof(int)));
                dt.Columns.Add(new DataColumn("Name", typeof(string)));
                dt.Columns.Add(new DataColumn("Age", typeof(int)));
                DataColumn[] pk = new DataColumn[1];
                pk[0] = dt.Columns[0];
                dt.PrimaryKey = pk;
            }
        }

        //
        // GET: /Person/

        public ActionResult Index()
        {
            List<Person> lstPerson = new List<Person>();
            foreach (DataRow dr in dt.Rows)
            {
                Person p = new Person();
                p.Code = Convert.ToInt32(dr[0].ToString());
                p.Name = dr[1].ToString();
                p.Age = Convert.ToInt32(dr[2].ToString());
                lstPerson.Add(p);
            }
            return View(lstPerson);
        }

        //
        // GET: /Person/Details/5

        public ActionResult Details(int id)
        {
            DataRow dr = dt.Rows.Find(id);
            Person p = new Person();
            p.Code = Convert.ToInt32(dr[0].ToString());
            p.Name = dr[1].ToString();
            p.Age = Convert.ToInt32(dr[2].ToString());
            return View(p);
        }

        //
        // GET: /Person/Create

        public ActionResult Create()
        {
            return View();
        }

        //
        // POST: /Person/Create

        [HttpPost]
        public ActionResult Create(Person p)
        {
            DataRow dr = dt.NewRow();
            dr[0] = p.Code;
            dr[1] = p.Name;
            dr[2] = p.Age;
            dt.Rows.Add(dr);
            return RedirectToAction("Index");
        }

        //
        // GET: /Person/Edit/5

        public ActionResult Edit(int id)
        {
            DataRow dr = dt.Rows.Find(id);
            Person p = new Person();
            p.Code = Convert.ToInt32(dr[0].ToString());
            p.Name = dr[1].ToString();
            p.Age = Convert.ToInt32(dr[2].ToString());
            return View(p);
        }

        //
        // POST: /Person/Edit/5

        [HttpPost]
        public ActionResult Edit(int id, Person p)
        {
            DataRow dr = dt.Rows.Find(id);
            dr[0] = p.Code;
            dr[1] = p.Name;
            dr[2] = p.Age;
            return RedirectToAction("Index");
        }

        //
        // GET: /Person/Delete/5

        public ActionResult Delete(int id)
        {
            DataRow dr = dt.Rows.Find(id);
            Person p = new Person();
            p.Code = Convert.ToInt32(dr[0].ToString());
            p.Name = dr[1].ToString();
            p.Age = Convert.ToInt32(dr[2].ToString());
            return View(p);
        }

        //
        // POST: /Person/Delete/5

        [HttpPost]
        public ActionResult Delete(int id, Person p)
        {
            DataRow dr = dt.Rows.Find(id);
            dt.Rows.Remove(dr);
            return RedirectToAction("Index");
        }
    }
}